
#ifndef _H_PLUG
#define _H_PLUG

#include <stddef.h>
#include <stdbool.h>

typedef void* (*plug_init_f)        (void);
typedef void* (*plug_pre_reload_f)  (void);
typedef void  (*plug_post_reload_f) (void*);
typedef void  (*plug_poll_f)        (char*, size_t);
typedef void  (*plug_free_f)        (void);

typedef struct plug_t {
    char* name;
    char* version;
} plug_t;

typedef struct plug_int_t {
    char* path;
    plug_init_f f_init; 
    plug_pre_reload_f f_pre_reload;
    plug_post_reload_f f_post_reload;
    plug_poll_f f_poll;
    plug_free_f f_free;
    plug_t* state;
} plug_int_t;

void setup_plugins(char* plugin_path);
char* poll_plugins(char* sep);
void free_plugins(void);
void reload_plugins(void);

#endif

