#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <assert.h>
#include <stdbool.h>

typedef struct plug_t {
    char* name;
    char* version;
    FILE* fp;
} plug_t;


static plug_t* p = {0};


char* batt_files[] = {
    "/sys/class/power_supply/BAT0/capacity",
    "/sys/class/power_supply/BAT1/capacity"
};

void* plug_init(void) {
    p = malloc(sizeof(plug_t));
    assert(p);
    p->name = "Battery";
    p->version = "0.0.1";

    for (size_t i = 0; i < sizeof(batt_files)/sizeof(batt_files[0]); i++) {
        if (access(batt_files[i], F_OK) == 0) {
            p->fp = fopen(batt_files[i], "r");
            if (p->fp) {
                printf("Opened %s\n", batt_files[i]);
                break;
            }
        }
    }

    if (!p->fp) {
        printf("MODULE: ERROR: Unable to find battery\n");
        return NULL;
    }

    return p;
}

void* plug_pre_reload(void) {
    return p;
}

void plug_post_reload(void* pp) {
    p = pp;
}

void plug_poll(char* buf, size_t len) {
    if (!p->fp) return;
    int perc = 0;
    fseek(p->fp, 0, SEEK_SET);
    fscanf(p->fp, "%d", &perc);
    snprintf(buf, len, "Batt: %d%%", perc);
}

void plug_free(void) {}
